!xbZEtB^QfocZo    (c)2024 }CRZ@Vc 
!Q, foc calculation of Bessel filter (c)2024 Maikon-Giken  Akira Sawada
!
!          Maikon-Giken URL https://www2u.biglobe.ne.jp/~tequila/micon/index.html
! Required SW:Decimal BASIC https://hp.vector.co.jp/authors/VA008683/english/index.htm
!--------------------------------------------------------------------------------------

!--CUSTOMISE----------------------------------------------------------------
!OPTION ARITHMETIC DECIMAL_HIGH  ! Activate DECIMAL_HIGH in case of n > 10
LET nmax = 10                    !    10 at normal, 215(max) at DECIMAL_HIGH
LET e = 1e-11                    ! 1e-11 at normal,   1e-700 at DECIMAL_HIGH
LET g = 2                        ! = 1 / Taget-Gain^2
LET h = 0                        ! 0:batch of n=2 to nmax, 1:input n
!---------------------------------------------------------------------------

OPTION BASE 0
DIM a(220),b(220),c(220),RA(220),RD(220),IM(220),IMD(220),j(5),ji(5)
DECLARE NUMERIC n, p, q, dp, dq, w, qf,wc, dwc, z
DECLARE NUMERIC m, nn, i, r, d, lp, k, tr, ti, trd, tid, s
DECLARE STRING fname$

!------input file name
INPUT  PROMPT "File Base =":fname$
OPEN #1 : NAME fname$, ACCESS OUTPUT
!PRINT#1:"nmax=";nmax
!PRINT#1:"e=";e
PRINT#1 : "Bessel filter design table"
PRINT#1 : "--n , stage, foc---------, Q ---------"
CLOSE#1

LET n = 2
10 !-------input n or auto loop
   IF h > 0 THEN INPUT  PROMPT "-1(end) or n(>2)=":n
   IF n < 0 THEN GOTO 9999
   IF n < 2 OR n > nmax THEN GOTO 10
   OPEN #1 : NAME fname$, ACCESS OUTPUT
   PRINT n
   IF n = 2 THEN   ! n=2 only----------
      LET w = SQR(0.5 + SQR(1.25))
      LET qf = 1 / SQR(3)
      !PRINT #1:"n= 2 , s^n--s^0 = 1 , 3 , 3 ,"
      PRINT#1, USING"--% ,  --% ,":2,1;
      IF e < 1e-11 THEN
         PRINT#1: w;", ";qf
      ELSE
         PRINT#1, USING"-%.######### ,-%.#########":w,qf
      END IF
      CLOSE #1
      IF h = 0 THEN LET n = n + 1
      GOTO 10
   END IF
   ! ----------------------------------
    
   FOR i=0 TO n + 3
      LET a(i)=0
      LET ra(i)=0
      LET rd(i)=0
      LET im(i)=0
      LET imd(i)=0
   NEXT i
   !-----------------------------
   !---- Equation generation ----
   !-----------------------------
   LET m=2*n-1
   LET ra(n)=m
   LET im(n-2)=-1
   FOR i=m-2 TO 1 STEP -2
      FOR k = 0 TO n
         LET rd(k)=ra(k)*i+im(k)
         IF i=1 THEN
            LET imd(k)=ra(k+1)
         ELSE
            LET imd(k)=-ra(k+2)
         END IF
      NEXT k   
      FOR k = 0 TO n
         LET ra(k)=rd(k)
         LET im(k)=imd(k)
      NEXT k   
   NEXT i
   LET j(0)=1
   LET j(1)=0
   LET j(2)=-1
   LET j(3)=0
   LET ji(0)=0
   LET ji(1)=1
   LET ji(2)=0
   LET ji(3)=-1
   LET k=0
   FOR i=n TO 0 STEP -1
      LET a(i)= ra(i)*j(k) + im(i)*ji(k)
      LET k = MOD(k+1, 4)
   NEXT i
   !
   ! Equation output 
   !   PRINT #1:"n=";n;",";
   !   PRINT #1:"s^n--s^0 =";
   !   FOR i=0 TO n
   !      PRINT #1:a(i);",";
   !   NEXT i
   !   PRINT #1
   ! 
   !-----------------------------------------------------
   !-- Find the angular frequency at Target-Gain --------
   !-----------------------------------------------------
   LET k=1
   FOR i=n TO 1 STEP -1
      LET rd(i) = ra(i-1)*k
      LET imd(i) = im(i-1)*k
      LET k = k+1
   NEXT i
   LET rd(0)=0
   LET imd(0)=0
   LET lp=0
   LET wc=1
   !loop-------
   DO
      LET tr=0
      LET ti=0
      LET trd=0
      LET tid=0
      FOR i =0 TO n
         LET tr=tr*wc+ra(i)
         LET ti=ti*wc+im(i)
         LET trd=trd*wc+rd(i)
         LET tid=tid*wc+imd(i)
      NEXT i
      LET z = tr*tr + ti*ti -g*a(n)*a(n)
      LET dwc = z /2 /(trd*tr + tid*ti)
      LET wc = wc - dwc
      LET lp=lp+1
      IF lp>1000 THEN GOTO 9999
   LOOP WHILE ABS(dwc) > e
   !
   !-------------------------------
   !-- Find each wo, foc, Q -------
   !-------------------------------
   LET nn=n
   LET b(0)=1
   LET c(0)=1
   LET s = 0
   FOR m = 1 TO n-2 STEP 2
      LET p=1
      LET q=1
      LET lp=0
      !loop--------------------------
      DO
         LET b(1)=a(1)-p
         FOR i=2 TO nn
            LET b(i)=a(i)-p*b(i-1)-q*b(i-2)
         NEXT i
         !--------------------------
         LET c(1)=b(1)-p
         FOR i=2 TO nn-1
            LET c(i)=b(i)-p*c(i-1)-q*c(i-2)
         NEXT i
         !--------------------------
         LET r= c(nn-2)*c(nn-2)-(c(nn-1)-b(nn-1))*c(nn-3)
         LET dp = (b(nn-1)*c(nn-2)-b(nn)*c(nn-3))/r
         LET dq = (-b(nn-1)*(c(nn-1)-b(nn-1))+b(nn)*c(nn-2))/r
         LET p=p+dp
         LET q=q+dq
         LET lp=lp+1
         IF lp>1000 THEN GOTO 9999
      LOOP WHILE ABS(dp) > e OR ABS(dq) > e
      !
      !LET d = p*p/4-q
      !PRINT n,m
      !PRINT -p/2
      !PRINT SQR(ABS(d))
      LET w = SQR(q)
      LET ra(s)= q      !wo^2
      LET rd(s)= w      !wo
      LET im(s)= w/wc   !foc
      LET imd(s)=w/p    !Q
      LET s=s+1
      LET nn=nn-2
      FOR i = 1 TO nn
         LET a(i)=b(i)
      NEXT i
   NEXT m
   !
   IF (nn=1) THEN
      LET w=a(1)
      LET ra(s)= a(1)   !wo
      LET rd(s)= w      !wo
      LET im(s)= w/wc   !foc
      LET imd(s)=0      !1st order
      !PRINT n,n
      !PRINT -a(1)
   ELSE
      LET w = SQR(a(2))
      LET ra(s)= a(2)   !wo^2
      LET rd(s)= w      !wo
      LET im(s)= w/wc   !foc
      LET imd(s)=w/a(1) !Q
      !LET d = b(1)*b(1)/4-b(2)
      !PRINT n,m
      !PRINT -b(1)/2
      !PRINT SQR(ABS(d))
   END IF
   !
   !---------------------
   !-- Sort by Q --------
   !---------------------
   FOR i = 0 TO s-1
      FOR k = i+1 TO s
         IF imd(i) > imd(k) THEN
            LET w = ra(i)
            LET ra(i) = ra(k)
            LET ra(k) = w
            LET w = rd(i)
            LET rd(i) = rd(k)
            LET rd(k) = w
            LET w = im(i)
            LET im(i) = im(k)
            LET im(k) = w
            LET w = imd(i)
            LET imd(i) = imd(k)
            LET imd(k) = w
         END IF
      NEXT k
   NEXT i
   !
   !---------------------
   !-- Output foc, Q ----
   !---------------------
   !PRINT#1:"wc=";wc
   FOR i = 0 TO s
      PRINT#1, USING"--% ,  --% ,":n,i+1;
      IF e < 1e-11 THEN
         PRINT#1: im(i);", ";
         IF imd(i) > 0 THEN PRINT#1:imd(i) ELSE PRINT#1:" 1st order"
      ELSE
         PRINT#1, USING"-%.######### ,":im(i);
         IF imd(i) > 0 THEN PRINT#1, USING"-%.#########":imd(i) ELSE PRINT#1:"   1st order"
      END IF
   NEXT i
   CLOSE#1
   !
   ! precision check
   LET w=1
   FOR i=0 TO s
      LET w=w*ra(i)
   NEXT i
   LET w=w/a(n)-1
   PRINT w
   !
   IF h = 0 THEN LET n = n + 1
   IF n <= nmax THEN GOTO 10
9999 !------END---------
     CLOSE #1 
     PRINT "END"
  END
